unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
  rpi_hal;

type

  { TForm1 }

  TForm1 = class(TForm)
    ToggleBox1: TToggleBox;
    ToggleBox2: TToggleBox;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure ToggleBox1Change(Sender: TObject);
    procedure ToggleBox2Change(Sender: TObject);
  private
    { private declarations }
    isr_1 : isr_t;
    isr_2 : isr_t;
  public
    { public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

const
  GPIO20 = 20;
  GPIO21 = 21;

function my_isr(gpio_nr:integer):integer;
// for gpio_int testing. will be called on interrupt
const waittim_ms=1;
begin
  writeln ('my_isr fired for GPIO',gpio_nr,' servicetime: ',waittim_ms:0,'ms');
  sleep(waittim_ms);
  my_isr:=999;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  writeln('Show CPU-Info, RPI-HW-Info and Registers:');
  rpi_show_all_info;

  isr_1.gpio := GPIO20;
  isr_1.rising_edge := true;
  gpio_set_int(isr_1, GPIO20, @my_isr, true, OUTPUT);
  gpio_int_enable(isr_1);

  isr_2.gpio := GPIO21;
  isr_2.rising_edge := true;
  gpio_set_int(isr_2, GPIO21, @my_isr, true, OUTPUT);
  gpio_int_enable(isr_2);
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  gpio_int_disable(isr_1);
  gpio_int_release(isr_1);

  gpio_int_disable(isr_2);
  gpio_int_release(isr_2);
end;

procedure TForm1.ToggleBox1Change(Sender: TObject);
begin
  gpio_set_pin(isr_1.gpio, ToggleBox1.Checked);
end;

procedure TForm1.ToggleBox2Change(Sender: TObject);
begin
  gpio_set_pin(isr_2.gpio, ToggleBox2.Checked);
end;

end.

